Index: uspace/drv/bus/usb/ohci/hc.h
===================================================================
--- uspace/drv/bus/usb/ohci/hc.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/hc.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -41,9 +41,7 @@
 
 #include <usb/usb.h>
-#include <usb/host/device_keeper.h>
-#include <usb/host/usb_endpoint_manager.h>
-#include <usbhc_iface.h>
+#include <usb/host/hcd.h>
 
-#include "batch.h"
+#include "ohci_batch.h"
 #include "ohci_regs.h"
 #include "root_hub.h"
@@ -53,8 +51,6 @@
 /** Main OHCI driver structure */
 typedef struct hc {
-	/** USB bus driver, devices and addresses */
-	usb_device_keeper_t manager;
-	/** USB bus driver, endpoints */
-	usb_endpoint_manager_t ep_manager;
+	/** Generic USB hc driver */
+	hcd_t generic;
 
 	/** Memory mapped I/O registers area */
@@ -81,6 +77,6 @@
 int hc_get_irq_commands(
     irq_cmd_t cmds[], size_t cmd_size, uintptr_t regs, size_t reg_size);
+int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun);
 int hc_init(hc_t *instance, uintptr_t regs, size_t reg_size, bool interrupts);
-int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun);
 
 /** Safely dispose host controller internal structures
@@ -88,25 +84,10 @@
  * @param[in] instance Host controller structure to use.
  */
-static inline void hc_fini(hc_t *instance)
-	{ /* TODO: implement*/ };
+static inline void hc_fini(hc_t *instance) { /* TODO: implement*/ };
 
-int hc_add_endpoint(hc_t *instance, usb_address_t address, usb_endpoint_t ep,
-    usb_speed_t speed, usb_transfer_type_t type, usb_direction_t direction,
-    size_t max_packet_size, size_t size, unsigned interval);
-int hc_remove_endpoint(hc_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction);
-endpoint_t * hc_get_endpoint(hc_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction, size_t *bw);
+void hc_enqueue_endpoint(hc_t *instance, endpoint_t *ep);
+void hc_dequeue_endpoint(hc_t *instance, endpoint_t *ep);
 
-int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch);
 void hc_interrupt(hc_t *instance, uint32_t status);
-
-/** Get and cast pointer to the driver data
- *
- * @param[in] fun DDF function pointer
- * @return cast pointer to driver_data
- */
-static inline hc_t * fun_to_hc(ddf_fun_t *fun)
-	{ return fun->driver_data; }
 #endif
 /**
Index: uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.c
===================================================================
--- uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -39,6 +39,6 @@
 static unsigned togg[2] = { TD_STATUS_T_0, TD_STATUS_T_1 };
 
-void td_init(
-    td_t *instance, usb_direction_t dir, void *buffer, size_t size, int toggle)
+void td_init(td_t *instance,
+    usb_direction_t dir, const void *buffer, size_t size, int toggle)
 {
 	assert(instance);
Index: uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -75,6 +75,6 @@
 } __attribute__((packed)) td_t;
 
-void td_init(
-    td_t *instance, usb_direction_t dir, void *buffer, size_t size, int toggle);
+void td_init(td_t *instance,
+    usb_direction_t dir, const void *buffer, size_t size, int toggle);
 
 inline static void td_set_next(td_t *instance, td_t *next)
Index: uspace/drv/bus/usb/ohci/ohci.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/ohci.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -42,8 +42,6 @@
 
 #include "ohci.h"
-#include "iface.h"
 #include "pci.h"
 #include "hc.h"
-#include "root_hub.h"
 
 typedef struct ohci {
@@ -52,5 +50,4 @@
 
 	hc_t hc;
-	rh_t rh;
 } ohci_t;
 
@@ -89,7 +86,8 @@
 {
 	assert(fun);
-	usb_device_keeper_t *manager = &dev_to_ohci(fun->dev)->hc.manager;
-
-	usb_address_t addr = usb_device_keeper_find(manager, handle);
+	usb_device_manager_t *manager =
+	    &dev_to_ohci(fun->dev)->hc.generic.dev_manager;
+
+	const usb_address_t addr = usb_device_manager_find(manager, handle);
 	if (addr < 0) {
 		return addr;
@@ -129,5 +127,5 @@
 /** Standard USB HC options (HC interface) */
 static ddf_dev_ops_t hc_ops = {
-	.interfaces[USBHC_DEV_IFACE] = &hc_iface, /* see iface.h/c */
+	.interfaces[USBHC_DEV_IFACE] = &hcd_iface,
 };
 /*----------------------------------------------------------------------------*/
@@ -150,4 +148,6 @@
 int device_setup_ohci(ddf_dev_t *device)
 {
+	assert(device);
+
 	ohci_t *instance = malloc(sizeof(ohci_t));
 	if (instance == NULL) {
@@ -155,24 +155,20 @@
 		return ENOMEM;
 	}
+	instance->rh_fun = NULL;
+	instance->hc_fun = NULL;
 
 #define CHECK_RET_DEST_FREE_RETURN(ret, message...) \
 if (ret != EOK) { \
 	if (instance->hc_fun) { \
-		instance->hc_fun->ops = NULL; \
-		instance->hc_fun->driver_data = NULL; \
 		ddf_fun_destroy(instance->hc_fun); \
 	} \
 	if (instance->rh_fun) { \
-		instance->rh_fun->ops = NULL; \
-		instance->rh_fun->driver_data = NULL; \
 		ddf_fun_destroy(instance->rh_fun); \
 	} \
 	free(instance); \
-	device->driver_data = NULL; \
 	usb_log_error(message); \
 	return ret; \
 } else (void)0
 
-	instance->rh_fun = NULL;
 	instance->hc_fun = ddf_fun_create(device, fun_exposed, "ohci_hc");
 	int ret = instance->hc_fun ? EOK : ENOMEM;
@@ -194,5 +190,5 @@
 	ret = pci_get_my_registers(device, &reg_base, &reg_size, &irq);
 	CHECK_RET_DEST_FREE_RETURN(ret,
-	    "Failed to get memory addresses for %" PRIun ": %s.\n",
+	    "Failed to get register memory addresses for %" PRIun ": %s.\n",
 	    device->handle, str_error(ret));
 	usb_log_debug("Memory mapped regs at %p (size %zu), IRQ %d.\n",
@@ -201,4 +197,6 @@
 	const size_t cmd_count = hc_irq_cmd_count();
 	irq_cmd_t irq_cmds[cmd_count];
+	irq_code_t irq_code = { .cmdcount = cmd_count, .cmds = irq_cmds };
+
 	ret =
 	    hc_get_irq_commands(irq_cmds, sizeof(irq_cmds), reg_base, reg_size);
@@ -206,5 +204,4 @@
 	    "Failed to generate IRQ commands: %s.\n", str_error(ret));
 
-	irq_code_t irq_code = { .cmdcount = cmd_count, .cmds = irq_cmds };
 
 	/* Register handler to avoid interrupt lockup */
@@ -234,6 +231,6 @@
 #define CHECK_RET_FINI_RETURN(ret, message...) \
 if (ret != EOK) { \
+	hc_fini(&instance->hc); \
 	unregister_interrupt_handler(device, irq); \
-	hc_fini(&instance->hc); \
 	CHECK_RET_DEST_FREE_RETURN(ret, message); \
 } else (void)0
@@ -248,8 +245,9 @@
 	    "Failed to add OHCI to HC class: %s.\n", str_error(ret));
 
-	hc_register_hub(&instance->hc, instance->rh_fun);
-	return EOK;
-
-#undef CHECK_RET_DEST_FUN_RETURN
+	ret = hc_register_hub(&instance->hc, instance->rh_fun);
+	CHECK_RET_FINI_RETURN(ret,
+	    "Failed to register OHCI root hub: %s.\n", str_error(ret));
+	return ret;
+
 #undef CHECK_RET_FINI_RETURN
 }
Index: uspace/drv/bus/usb/ohci/ohci_batch.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_batch.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/ohci/ohci_batch.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,358 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbohci
+ * @{
+ */
+/** @file
+ * @brief OHCI driver USB transaction structure
+ */
+#include <errno.h>
+#include <str_error.h>
+
+#include <usb/usb.h>
+#include <usb/debug.h>
+
+#include "ohci_batch.h"
+#include "ohci_endpoint.h"
+#include "utils/malloc32.h"
+
+static void (*const batch_setup[])(ohci_transfer_batch_t*, usb_direction_t);
+/*----------------------------------------------------------------------------*/
+/** Safely destructs ohci_transfer_batch_t structure
+ *
+ * @param[in] ohci_batch Instance to destroy.
+ */
+static void ohci_transfer_batch_dispose(ohci_transfer_batch_t *ohci_batch)
+{
+	if (!ohci_batch)
+		return;
+	unsigned i = 0;
+	if (ohci_batch->tds) {
+		for (; i< ohci_batch->td_count; ++i) {
+			if (i != ohci_batch->leave_td)
+				free32(ohci_batch->tds[i]);
+		}
+		free(ohci_batch->tds);
+	}
+	usb_transfer_batch_dispose(ohci_batch->usb_batch);
+	free32(ohci_batch->device_buffer);
+	free(ohci_batch);
+}
+/*----------------------------------------------------------------------------*/
+void ohci_transfer_batch_finish_dispose(ohci_transfer_batch_t *ohci_batch)
+{
+	assert(ohci_batch);
+	assert(ohci_batch->usb_batch);
+	usb_transfer_batch_finish(ohci_batch->usb_batch,
+	    ohci_batch->device_buffer + ohci_batch->usb_batch->setup_size,
+	    ohci_batch->usb_batch->buffer_size);
+	ohci_transfer_batch_dispose(ohci_batch);
+}
+/*----------------------------------------------------------------------------*/
+ohci_transfer_batch_t * ohci_transfer_batch_get(usb_transfer_batch_t *usb_batch)
+{
+	assert(usb_batch);
+#define CHECK_NULL_DISPOSE_RET(ptr, message...) \
+if (ptr == NULL) { \
+	usb_log_error(message); \
+	ohci_transfer_batch_dispose(ohci_batch); \
+	return NULL; \
+} else (void)0
+
+	ohci_transfer_batch_t *ohci_batch =
+	    calloc(1, sizeof(ohci_transfer_batch_t));
+	CHECK_NULL_DISPOSE_RET(ohci_batch,
+	    "Failed to allocate OHCI batch data.\n");
+	link_initialize(&ohci_batch->link);
+	ohci_batch->td_count =
+	    (usb_batch->buffer_size + OHCI_TD_MAX_TRANSFER - 1)
+	    / OHCI_TD_MAX_TRANSFER;
+	/* Control transfer need Setup and Status stage */
+	if (usb_batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
+		ohci_batch->td_count += 2;
+	}
+
+	/* We need an extra place for TD that was left at ED */
+	ohci_batch->tds = calloc(ohci_batch->td_count + 1, sizeof(td_t*));
+	CHECK_NULL_DISPOSE_RET(ohci_batch->tds,
+	    "Failed to allocate OHCI transfer descriptors.\n");
+
+	/* Add TD left over by the previous transfer */
+	ohci_batch->ed = ohci_endpoint_get(usb_batch->ep)->ed;
+	ohci_batch->tds[0] = ohci_endpoint_get(usb_batch->ep)->td;
+	ohci_batch->leave_td = 0;
+	unsigned i = 1;
+	for (; i <= ohci_batch->td_count; ++i) {
+		ohci_batch->tds[i] = malloc32(sizeof(td_t));
+		CHECK_NULL_DISPOSE_RET(ohci_batch->tds[i],
+		    "Failed to allocate TD %d.\n", i );
+	}
+
+
+	/* NOTE: OHCI is capable of handling buffer that crosses page boundaries
+	 * it is, however, not capable of handling buffer that occupies more
+	 * than two pages (the first page is computed using start pointer, the
+	 * other using the end pointer) */
+        if (usb_batch->setup_size + usb_batch->buffer_size > 0) {
+		/* Use one buffer for setup and data stage */
+		ohci_batch->device_buffer =
+		    malloc32(usb_batch->setup_size + usb_batch->buffer_size);
+                CHECK_NULL_DISPOSE_RET(ohci_batch->device_buffer,
+                    "Failed to allocate device accessible buffer.\n");
+		/* Copy setup data */
+                memcpy(ohci_batch->device_buffer, usb_batch->setup_buffer,
+		    usb_batch->setup_size);
+		/* Copy generic data */
+		if (usb_batch->ep->direction != USB_DIRECTION_IN)
+			memcpy(
+			    ohci_batch->device_buffer + usb_batch->setup_size,
+			    usb_batch->buffer, usb_batch->buffer_size);
+        }
+	ohci_batch->usb_batch = usb_batch;
+
+	const usb_direction_t dir = usb_transfer_batch_direction(usb_batch);
+	assert(batch_setup[usb_batch->ep->transfer_type]);
+	batch_setup[usb_batch->ep->transfer_type](ohci_batch, dir);
+
+	return ohci_batch;
+#undef CHECK_NULL_DISPOSE_RET
+}
+/*----------------------------------------------------------------------------*/
+/** Check batch TDs' status.
+ *
+ * @param[in] ohci_batch Batch structure to use.
+ * @return False, if there is an active TD, true otherwise.
+ *
+ * Walk all TDs (usually there is just one). Stop with false if there is an
+ * active TD. Stop with true if an error is found. Return true if the walk
+ * completes with the last TD.
+ */
+bool ohci_transfer_batch_is_complete(ohci_transfer_batch_t *ohci_batch)
+{
+	assert(ohci_batch);
+	assert(ohci_batch->usb_batch);
+
+	usb_log_debug("Batch %p checking %zu td(s) for completion.\n",
+	    ohci_batch->usb_batch, ohci_batch->td_count);
+	usb_log_debug2("ED: %x:%x:%x:%x.\n",
+	    ohci_batch->ed->status, ohci_batch->ed->td_head,
+	    ohci_batch->ed->td_tail, ohci_batch->ed->next);
+
+	size_t i = 0;
+	for (; i < ohci_batch->td_count; ++i) {
+		assert(ohci_batch->tds[i] != NULL);
+		usb_log_debug("TD %zu: %x:%x:%x:%x.\n", i,
+		    ohci_batch->tds[i]->status, ohci_batch->tds[i]->cbp,
+		    ohci_batch->tds[i]->next, ohci_batch->tds[i]->be);
+		if (!td_is_finished(ohci_batch->tds[i])) {
+			return false;
+		}
+		ohci_batch->usb_batch->error = td_error(ohci_batch->tds[i]);
+		if (ohci_batch->usb_batch->error != EOK) {
+			usb_log_debug("Batch %p found error TD(%zu):%x.\n",
+			    ohci_batch->usb_batch, i,
+			    ohci_batch->tds[i]->status);
+			/* Make sure TD queue is empty (one TD),
+			 * ED should be marked as halted */
+			ohci_batch->ed->td_tail =
+			    (ohci_batch->ed->td_head & ED_TDTAIL_PTR_MASK);
+			++i;
+			break;
+		}
+	}
+
+	assert(i <= ohci_batch->td_count);
+	ohci_batch->leave_td = i;
+
+	ohci_endpoint_t *ohci_ep = ohci_endpoint_get(ohci_batch->usb_batch->ep);
+	assert(ohci_ep);
+	ohci_ep->td = ohci_batch->tds[ohci_batch->leave_td];
+	assert(i > 0);
+	ohci_batch->usb_batch->transfered_size =
+	    ohci_batch->usb_batch->buffer_size;
+	for (--i;i < ohci_batch->td_count; ++i)
+		ohci_batch->usb_batch->transfered_size
+		    -= td_remain_size(ohci_batch->tds[i]);
+
+	/* Clear possible ED HALT */
+	ohci_batch->ed->td_head &= ~ED_TDHEAD_HALTED_FLAG;
+	/* just make sure that we are leaving the right TD behind */
+	const uint32_t pa = addr_to_phys(ohci_ep->td);
+	assert(pa == (ohci_batch->ed->td_head & ED_TDHEAD_PTR_MASK));
+	assert(pa == (ohci_batch->ed->td_tail & ED_TDTAIL_PTR_MASK));
+
+	return true;
+}
+/*----------------------------------------------------------------------------*/
+/** Starts execution of the TD list
+ *
+ * @param[in] ohci_batch Batch structure to use
+ */
+void ohci_transfer_batch_commit(ohci_transfer_batch_t *ohci_batch)
+{
+	assert(ohci_batch);
+	ed_set_end_td(ohci_batch->ed, ohci_batch->tds[ohci_batch->td_count]);
+}
+/*----------------------------------------------------------------------------*/
+/** Prepare generic control transfer
+ *
+ * @param[in] ohci_batch Batch structure to use.
+ * @param[in] dir Communication direction
+ *
+ * Setup stage with toggle 0 and direction BOTH(SETUP_PID)
+ * Data stage with alternating toggle and direction supplied by parameter.
+ * Status stage with toggle 1 and direction supplied by parameter.
+ */
+static void batch_control(ohci_transfer_batch_t *ohci_batch, usb_direction_t dir)
+{
+	assert(ohci_batch);
+	assert(ohci_batch->usb_batch);
+	assert(dir == USB_DIRECTION_IN || dir == USB_DIRECTION_OUT);
+	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", ohci_batch->ed,
+	    ohci_batch->ed->status, ohci_batch->ed->td_tail,
+	    ohci_batch->ed->td_head, ohci_batch->ed->next);
+	static const usb_direction_t reverse_dir[] = {
+		[USB_DIRECTION_IN]  = USB_DIRECTION_OUT,
+		[USB_DIRECTION_OUT] = USB_DIRECTION_IN,
+	};
+
+	int toggle = 0;
+	const char* buffer = ohci_batch->device_buffer;
+	const usb_direction_t data_dir = dir;
+	const usb_direction_t status_dir = reverse_dir[dir];
+
+	/* setup stage */
+	td_init(ohci_batch->tds[0], USB_DIRECTION_BOTH, buffer,
+		ohci_batch->usb_batch->setup_size, toggle);
+	td_set_next(ohci_batch->tds[0], ohci_batch->tds[1]);
+	usb_log_debug("Created CONTROL SETUP TD: %x:%x:%x:%x.\n",
+	    ohci_batch->tds[0]->status, ohci_batch->tds[0]->cbp,
+	    ohci_batch->tds[0]->next, ohci_batch->tds[0]->be);
+	buffer += ohci_batch->usb_batch->setup_size;
+
+	/* data stage */
+	size_t td_current = 1;
+	size_t remain_size = ohci_batch->usb_batch->buffer_size;
+	while (remain_size > 0) {
+		const size_t transfer_size =
+		    remain_size > OHCI_TD_MAX_TRANSFER ?
+		    OHCI_TD_MAX_TRANSFER : remain_size;
+		toggle = 1 - toggle;
+
+		td_init(ohci_batch->tds[td_current], data_dir, buffer,
+		    transfer_size, toggle);
+		td_set_next(ohci_batch->tds[td_current],
+		    ohci_batch->tds[td_current + 1]);
+		usb_log_debug("Created CONTROL DATA TD: %x:%x:%x:%x.\n",
+		    ohci_batch->tds[td_current]->status,
+		    ohci_batch->tds[td_current]->cbp,
+		    ohci_batch->tds[td_current]->next,
+		    ohci_batch->tds[td_current]->be);
+
+		buffer += transfer_size;
+		remain_size -= transfer_size;
+		assert(td_current < ohci_batch->td_count - 1);
+		++td_current;
+	}
+
+	/* status stage */
+	assert(td_current == ohci_batch->td_count - 1);
+	td_init(ohci_batch->tds[td_current], status_dir, NULL, 0, 1);
+	td_set_next(ohci_batch->tds[td_current],
+	    ohci_batch->tds[td_current + 1]);
+	usb_log_debug("Created CONTROL STATUS TD: %x:%x:%x:%x.\n",
+	    ohci_batch->tds[td_current]->status,
+	    ohci_batch->tds[td_current]->cbp,
+	    ohci_batch->tds[td_current]->next,
+	    ohci_batch->tds[td_current]->be);
+	usb_log_debug2(
+	    "Batch %p %s %s " USB_TRANSFER_BATCH_FMT " initialized.\n", \
+	    ohci_batch->usb_batch,
+	    usb_str_transfer_type(ohci_batch->usb_batch->ep->transfer_type),
+	    usb_str_direction(dir),
+	    USB_TRANSFER_BATCH_ARGS(*ohci_batch->usb_batch));
+}
+/*----------------------------------------------------------------------------*/
+/** Prepare generic data transfer
+ *
+ * @param[in] ohci_batch Batch structure to use.
+ * @paramp[in] dir Communication direction.
+ *
+ * Direction is supplied by the associated ep and toggle is maintained by the
+ * OHCI hw in ED.
+ */
+static void batch_data(ohci_transfer_batch_t *ohci_batch, usb_direction_t dir)
+{
+	assert(ohci_batch);
+	assert(ohci_batch->usb_batch);
+	assert(dir == USB_DIRECTION_IN || dir == USB_DIRECTION_OUT);
+	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", ohci_batch->ed,
+	    ohci_batch->ed->status, ohci_batch->ed->td_tail,
+	    ohci_batch->ed->td_head, ohci_batch->ed->next);
+
+	size_t td_current = 0;
+	size_t remain_size = ohci_batch->usb_batch->buffer_size;
+	char *buffer = ohci_batch->device_buffer;
+	while (remain_size > 0) {
+		const size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER
+		    ? OHCI_TD_MAX_TRANSFER : remain_size;
+
+		td_init(ohci_batch->tds[td_current], dir, buffer,
+		    transfer_size, -1);
+		td_set_next(ohci_batch->tds[td_current],
+		    ohci_batch->tds[td_current + 1]);
+
+		usb_log_debug("Created DATA TD: %x:%x:%x:%x.\n",
+		    ohci_batch->tds[td_current]->status,
+		    ohci_batch->tds[td_current]->cbp,
+		    ohci_batch->tds[td_current]->next,
+		    ohci_batch->tds[td_current]->be);
+
+		buffer += transfer_size;
+		remain_size -= transfer_size;
+		assert(td_current < ohci_batch->td_count);
+		++td_current;
+	}
+	usb_log_debug2(
+	    "Batch %p %s %s " USB_TRANSFER_BATCH_FMT " initialized.\n", \
+	    ohci_batch->usb_batch,
+	    usb_str_transfer_type(ohci_batch->usb_batch->ep->transfer_type),
+	    usb_str_direction(dir),
+	    USB_TRANSFER_BATCH_ARGS(*ohci_batch->usb_batch));
+}
+/*----------------------------------------------------------------------------*/
+static void (*const batch_setup[])(ohci_transfer_batch_t*, usb_direction_t) =
+{
+	[USB_TRANSFER_CONTROL] = batch_control,
+	[USB_TRANSFER_BULK] = batch_data,
+	[USB_TRANSFER_INTERRUPT] = batch_data,
+	[USB_TRANSFER_ISOCHRONOUS] = NULL,
+};
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/ohci/ohci_batch.h
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/ohci/ohci_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbohci
+ * @{
+ */
+/** @file
+ * @brief OHCI driver USB transaction structure
+ */
+#ifndef DRV_OHCI_BATCH_H
+#define DRV_OHCI_BATCH_H
+
+#include <adt/list.h>
+#include <usbhc_iface.h>
+#include <usb/usb.h>
+#include <usb/host/usb_transfer_batch.h>
+
+#include "hw_struct/transfer_descriptor.h"
+#include "hw_struct/endpoint_descriptor.h"
+
+/** OHCI specific data required for USB transfer */
+typedef struct ohci_transfer_batch {
+	/** Link */
+	link_t link;
+	/** Endpoint descriptor of the target endpoint. */
+	ed_t *ed;
+	/** List of TDs needed for the transfer */
+	td_t **tds;
+	/** Number of TDs used by the transfer */
+	size_t td_count;
+	/** Dummy TD to be left at the ED and used by the next transfer */
+	size_t leave_td;
+	/** Data buffer, must be accessible by the OHCI hw. */
+	char *device_buffer;
+	/** Generic USB transfer structure */
+	usb_transfer_batch_t *usb_batch;
+} ohci_transfer_batch_t;
+
+ohci_transfer_batch_t * ohci_transfer_batch_get(usb_transfer_batch_t *batch);
+bool ohci_transfer_batch_is_complete(ohci_transfer_batch_t *batch);
+void ohci_transfer_batch_commit(ohci_transfer_batch_t *batch);
+void ohci_transfer_batch_finish_dispose(ohci_transfer_batch_t *batch);
+/*----------------------------------------------------------------------------*/
+static inline ohci_transfer_batch_t *ohci_transfer_batch_from_link(link_t *l)
+{
+	assert(l);
+	return list_get_instance(l, ohci_transfer_batch_t, link);
+}
+#endif
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/ohci/ohci_endpoint.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_endpoint.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/ohci/ohci_endpoint.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbohci
+ * @{
+ */
+/** @file
+ * @brief OHCI driver
+ */
+#include "utils/malloc32.h"
+#include "ohci_endpoint.h"
+#include "hc.h"
+
+/** Callback to set toggle on ED.
+ *
+ * @param[in] hcd_ep hcd endpoint structure
+ * @param[in] toggle new value of toggle bit
+ */
+static void ohci_ep_toggle_set(void *ohci_ep, int toggle)
+{
+	ohci_endpoint_t *instance = ohci_ep;
+	assert(instance);
+	assert(instance->ed);
+	ed_toggle_set(instance->ed, toggle);
+}
+/*----------------------------------------------------------------------------*/
+/** Callback to get value of toggle bit.
+ *
+ * @param[in] hcd_ep hcd endpoint structure
+ * @return Current value of toggle bit.
+ */
+static int ohci_ep_toggle_get(void *ohci_ep)
+{
+	ohci_endpoint_t *instance = ohci_ep;
+	assert(instance);
+	assert(instance->ed);
+	return ed_toggle_get(instance->ed);
+}
+/*----------------------------------------------------------------------------*/
+/** Disposes hcd endpoint structure
+ *
+ * @param[in] hcd_ep endpoint structure
+ */
+static void ohci_endpoint_fini(endpoint_t *ep)
+{
+	ohci_endpoint_t *instance = ep->hc_data.data;
+	hc_dequeue_endpoint(instance->hcd->private_data, ep);
+	if (instance) {
+		free32(instance->ed);
+		free32(instance->td);
+		free(instance);
+	}
+}
+/*----------------------------------------------------------------------------*/
+/** Creates new hcd endpoint representation.
+ *
+ * @param[in] ep USBD endpoint structure
+ * @return pointer to a new hcd endpoint structure, NULL on failure.
+ */
+int ohci_endpoint_init(hcd_t *hcd, endpoint_t *ep)
+{
+	assert(ep);
+	ohci_endpoint_t *ohci_ep = malloc(sizeof(ohci_endpoint_t));
+	if (ohci_ep == NULL)
+		return ENOMEM;
+
+	ohci_ep->ed = malloc32(sizeof(ed_t));
+	if (ohci_ep->ed == NULL) {
+		free(ohci_ep);
+		return ENOMEM;
+	}
+
+	ohci_ep->td = malloc32(sizeof(td_t));
+	if (ohci_ep->td == NULL) {
+		free32(ohci_ep->ed);
+		free(ohci_ep);
+		return ENOMEM;
+	}
+
+	ed_init(ohci_ep->ed, ep);
+	ed_set_td(ohci_ep->ed, ohci_ep->td);
+	endpoint_set_hc_data(
+	    ep, ohci_ep, ohci_endpoint_fini, ohci_ep_toggle_get, ohci_ep_toggle_set);
+	ohci_ep->hcd = hcd;
+	hc_enqueue_endpoint(hcd->private_data, ep);
+	return EOK;
+}
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/ohci/ohci_endpoint.h
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_endpoint.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/ohci/ohci_endpoint.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,72 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbohci
+ * @{
+ */
+/** @file
+ * @brief OHCI driver
+ */
+#ifndef DRV_OHCI_HCD_ENDPOINT_H
+#define DRV_OHCI_HCD_ENDPOINT_H
+
+#include <assert.h>
+#include <adt/list.h>
+#include <usb/host/endpoint.h>
+#include <usb/host/hcd.h>
+
+#include "hw_struct/endpoint_descriptor.h"
+#include "hw_struct/transfer_descriptor.h"
+
+/** Connector structure linking ED to to prepared TD. */
+typedef struct ohci_endpoint {
+	/** OHCI endpoint descriptor */
+	ed_t *ed;
+	/** Currently enqueued transfer descriptor */
+	td_t *td;
+	/** Linked list used by driver software */
+	link_t link;
+	/** Device using this ep */
+	hcd_t *hcd;
+} ohci_endpoint_t;
+
+int ohci_endpoint_init(hcd_t *hcd, endpoint_t *ep);
+
+/** Get and convert assigned ohci_endpoint_t structure
+ * @param[in] ep USBD endpoint structure.
+ * @return Pointer to assigned hcd endpoint structure
+ */
+static inline ohci_endpoint_t * ohci_endpoint_get(endpoint_t *ep)
+{
+	assert(ep);
+	return ep->hc_data.data;
+}
+
+#endif
+/**
+ * @}
+ */
